#!/usr/bin/python3

#### #!/usr/bin/env python

#### #!/usr/bin/python3.6
##### #!/usr/bin/env python

# coding: utf-8

import sys
import cgi
import cgitb; cgitb.enable()
import re, os, datetime
from collections import OrderedDict
import subprocess
import time
import random
from socket import gethostname

#time.sleep(1)


###print("hello", sys.file=stderr)
#print ("Content-type: text/html")
#print ("")
#print ("Hello World1 by python3")
#print("hello")
#exit()

dbAddress = ""
EMAIL_SUBJECT_PREFX = '[%s]' % gethostname()

if "inouejun-no-Mac-Pro" in EMAIL_SUBJECT_PREFX:
    dbAddress  = "/dbb/orthoscopeDB1b/"                   ## office
elif "inouejun-no-MacBook-Pro" in EMAIL_SUBJECT_PREFX:
    dbAddress   = "/Users/junINOUEpro/db/orthoscopeDB1e/" ## laptop
elif "inouejunnoMacBook-Pro.local" in EMAIL_SUBJECT_PREFX:
    dbAddress   = "/dbb/orthoscopeDB1e/" ## laptop black
else:
    dbAddress  = "/data/dbfe/orthoscopeDB1e/"             ## fish-evol

dirAddress = "../html/"     ## fish-evol.unit.oist.jp
    
print("Content-Type: text/html\n")
print("")
#print("EMAIL_SUBJECT_PREFX", EMAIL_SUBJECT_PREFX)
#exit()

resHTMLlines = '''
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="ja">

<head>
    <meta http-equiv="content-type" content="text/html;charset=shift_jis">
    <title>TITLE</title>
</head>


<body bgcolor="#eeeeee" leftmargin="20" marginheight="20" marginwidth="20" topmargin="20">
<table align="center" border="0" cellspacing="0" cellpadding="5" bgcolor="white">


<!-- title in blue box-->
<tr><td width="600"><div align="center">
<table width="100%" border="0" cellspacing="2" cellpadding="0" bgcolor="#000088" height="50">
<tr><td align="center" valign="middle"><div align="center">
    <font size="5" color=#FFFFFF face="Verdana, Arial, Helvetica, sans-serif"><b>TITLE</b></font>
</div></td></tr></table>
</div></td></tr>


<!-- Main -->
<tr>
  <td align="left" valign="top">Download: DOWNLOADMESSAGE</td>
</tr>


<!-- mail address box-->
<tr><td width="600"><table width="100%" border="0" cellspacing="2" cellpadding="0">
<tr><hr></tr>
<tr>
    <td width="20%">&nbsp;</td>
    <td align="center" width="40%"><a href="http://www.fish-evol.org/index_eng.html" target="_blank"><em>jun.inoueAToist.jp</em></a></td>
    <td width="20%"><div align="right"> <a href="link"></a></div></td>
</tr>
</table></td></tr>


</table></body>

</html>
'''


def delete_dirs():
    now = datetime.date.today()
    for dir in os.listdir(dirAddress + "testWork/"):
        if re.search("^\d", dir):
            mtime = datetime.date.fromtimestamp(int(os.path.getmtime(dirAddress + "testWork/" + dir)))
            base, ext = os.path.splitext(dir)
            if (now - mtime).days >= 3:
                rm_command = "rm -r " + dirAddress + "testWork/" + dir
                subprocess.call(rm_command, shell=True)

def StringGetFileExtension(string):
    string = re.split("\\\/", string)[-1]
    a      = re.split("\.", string)
    if (len(a) > 1):
        return a[-1]
    else:
        return None

def FileExtensionGetAllowUpload(allow_ext1, ext):
    for v in allow_ext1:
        if (v == ext):
            return True
    else:
        False

def uploadedFileSave(query):

    #if not (query.has_key("input_file")):
    if not "input_file" in query:
        print ("Error: Select sequence file.")
        exit()
    
    # Retrieve field object from name
    input_file = query['input_file']

    # Check the presence of TemporaryFile object
    if not (input_file.file):
        print("Error: Uploaded file does not contain TempraryFile object.")
        exit()

    # Check the extension
    file_ext = StringGetFileExtension(input_file.filename)
    allow_ext_seqFile = ["txt","fas"]
    if not (FileExtensionGetAllowUpload(allow_ext_seqFile, file_ext)):
        print('Error in your sequence file: The extension should be ".txt" or ".fas".')
        exit()

    blastEvalue       = query.getvalue("blastEvalue")
    blastTopHits      = query.getvalue("blastTopHits")
    taxonSamplingList = query.getlist("taxon_checkbox")
    
    if not os.path.exists(eachDirAddress):
        os.mkdir(eachDirAddress)
    fh = open(eachDirAddress + "000_uploaded.txt", "w")
    fh.write(input_file.file.read().decode())
    fh.close()

    return taxonSamplingList, blastEvalue, blastTopHits


def dbLinesMake():
    dbLinesFN = []
    for spNameTMP in taxonSamplingList:
        match = re.search("^([^_]+_)([^_]+)$", spNameTMP)
        spName = match.group(1)
        color = match.group(2)
        for dbLine in dbLinesTMP:
            if spName == dbLine[0]:
                deLineNew = [dbLine[0], dbLine[1], color]
                dbLinesFN.append(deLineNew)
    #for dbLine in dbLinesFN:
    #    print dbLine, "<br>"
    #exit()
    return dbLinesFN
### File uploading End



def resHtmlMaker():
    
    #resHTMLlines1 = ""
    #resHTMLlines1 = re.sub('RESULTMESSAGE', '', resHTMLlines)

    downloadFileName = "000_uploaded.txt"
    downloadMessage = '<a href="' + downloadFileName + '">' + downloadFileName + '</a>.'
    resHTMLlines1 = re.sub('DOWNLOADMESSAGE', downloadMessage, resHTMLlines)

    out = open(eachDirAddress + "300_resultsREA.html", "w")
    out.write(resHTMLlines1)
    out.close()


def makeCount():
    import fcntl
    
    dat = "./uploadingFileScripts/count.dat"
    
    fh = open(dat, "r+")
    fcntl.flock(fh.fileno(), fcntl.LOCK_EX)

    count = fh.read()
    count = int(count)
    count += 1
    count = str(count)

    fh.seek(0)
    fh.write(count)
    fcntl.flock(fh.fileno(), fcntl.LOCK_UN)

    fh.close()
    return count

###


######################################################################################################################
#################################### Main program ####################################################################
######################################################################################################################



#########################
### from HTML
startTime = time.time()
dirName_count = makeCount()
letters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
letters_rand = ''.join([random.choice(letters) for _ in range(6)])

dirname_rand = dirName_count + "-" + letters_rand
#dirname_rand = "689-dLUGni"
eachDirAddress = dirAddress + "testWork/" + str(dirname_rand) + "/"


delete_dirs()

taxonSamplingList, blastEvalue, blastTopHits = uploadedFileSave(cgi.FieldStorage())


#####
### from terminal

'''##### time fixed
eachDirAddress = "../html/testWork/" + str(dirname_rand) + "/"
blastEvalue    = 1e-3
blastTopHits   = 5
taxonSamplingList  = ['Gallus-gallus_Blue', 'Homo-sapiens_Blue']
'''#####
#########################


'''
'''

resHtmlMaker()


print ("taxonSamplingList:" + str(taxonSamplingList) + "<br>")
print ("blastEvalue:" + blastEvalue + "<br>")
print ("blastTopHits:" + blastTopHits + "<br>")
print ("<br>")

### https://qiita.com/fantm21/items/3dc7fbf4e935311488bc
elapsed_time = round((time.time() - startTime),1)
print ("Analysis time: {0}".format(elapsed_time) + " seconds")


htmlAddress = '<br>Finished: <a href="../testWork/' + str(dirname_rand) + '/300_resultsREA.html" target="_blank">' + str(dirname_rand) + '</a><br><br>'
#htmlAddress = '<br>Finished: <a href="http://localhost/testWork/'              + str(dirname_rand) + '/300_resultsREA.html" target="_blank">' + str(dirname_rand) + '</a><br><br>'

print(htmlAddress)
#print ("Analysis finished.<br>")


exit()
